// Copyright (c) 1999-2000 David Muse
// See the COPYING file for more information

#include <config.h>

#include <iostream.h>

#include <stdio.h>
#include <string.h>
#ifdef HAVE_STRINGS_H
	#include <strings.h>
#endif

#include <rudiments/text.h>

void	text::upper(char *string) {

	int	i=0;
	while (string[i]) {
		if (string[i]>='a' && string[i]<='z') {
			string[i]=string[i]-32;
		}
		i++;
	}
}

void	text::lower(char *string) {

	int	i=0;
	while (string[i]) {
		if (string[i]>='A' && string[i]<='Z') {
			string[i]=string[i]+32;
		}
		i++;
	}
}

void	text::rightTrim(char *string) {
	rightTrim(string,' ');
}

void	text::rightTrim(char *string,char character) {

	if (string && string[0]) {

		int	i=0;

		// advance to the last character in the string
		while (string[i]) {
			i++;
		}
		i--;

		// back up to the first instance of the character to trim
		while (string[i]==character) { 
			i--;
		}
		i++;

		// terminate the string there
		string[i]=(char)NULL;
	}
}

void	text::leftTrim(char *string) {
	leftTrim(string,' ');
}

void	text::leftTrim(char *string, char character) {

	if (string && string[0]) {

		int	i=0;
		int	j=0;

		// advance past all of the characters we want to replace
		while (string[i]==character) {
			i++;
		}
	
		// swap chars to front of string
		while (string[i]) {
			string[j]=string[i];
			j++;
			i++;
		}
		// store a null to the new end of string
		string[j]=(char)NULL;
	}
}

void	text::bothTrim(char *string) {
	bothTrim(string,' ');
}

void	text::bothTrim(char *string, char character) {
	leftTrim(string,character);
	rightTrim(string,character);
}

void	text::strip(char *string, char character) {

	int	index=0;
	int	total=0;

	while (string[index]) {
		if (string[index]==character) {
			total++;
		} else {
			if (total) {
				string[index-total]=string[index];
			}
		}
		index++;
	}
	string[index-total]=(char)NULL;
}

void	text::strip(char *string1, char *string2) {

	int	str2len=strlen(string2);
	int	index=0;
	int	total=0;

	while (string1[index]) {
		if (!strncmp(string1+index,string2,str2len)) {
			total=total+str2len;
			index=index+str2len;
		} else {
			if (total) {
				string1[index-total]=string1[index];
			}
			index++;
		}
	}
	string1[index-total]=(char)NULL;
}

int	text::isInteger(char *string) {

	char	*ptr=string;
	while (*ptr) {
		if (((*ptr>'9' || *ptr<'0') && *ptr!='-') || 
			(ptr>string && *ptr=='-')) {
			return 0;
		}
		ptr++;
	}
	return	1;
}

int	text::isNumber(char *string) {

	int	decimal=0;
	char	*ptr=string;
	while (*ptr) {
		if (((*ptr>'9' || *ptr<'0') && *ptr!='-' && *ptr!='.') || 
			(ptr>string && *ptr=='-') || (decimal && *ptr=='.')) {
			return 0;
		}
		if (*ptr=='.') {
			decimal=1;
		}
		ptr++;
	}
	return	1;
}

char	*text::httpEscape(char *input) {

	char	*output=new char[strlen(input)*3+1];
	char	*outptr=output;
	char	*ptr=input;
	
	while (*ptr) {
		if (*ptr==' ') {
			(*outptr)='+';
		} else if ((*ptr>='a' && *ptr<='z') || 
				(*ptr>='A' && *ptr<='Z') ||
				(*ptr>='0' && *ptr<='9')) {
			(*outptr)=*ptr;
		} else {
			sprintf(outptr,"%c%02X",'%',*ptr);
			outptr=outptr+2;
		}
		outptr++;
		ptr++;
	}
	(*outptr)=(char)NULL;

	return output;
}
