// Copyright (c) 2001  David Muse
// See the file COPYING for more information

#include <rudiments/daemonprocess.h>

#include <config.h>

#include <stdlib.h>
#include <unistd.h>
#include <iostream.h>

daemonprocess	*dmn;

RETSIGTYPE	shutDown() {

	cout << "shutting down" << endl;

	// clean up
	delete dmn;
	unlink("/tmp/dmn.pidfile");
	exit(0);
}

int	main() {

	// launch the listener
	dmn=new daemonprocess();
	dmn->handleShutDown((RETSIGTYPE *)shutDown);

	int	pid=dmn->checkForPidFile("/tmp/dmn.pidfile");
	if (pid) {
		cout << "Sorry, an instance of this daemon is already running with process id: " << pid << endl;
		delete dmn;
		exit(0);
	}

	dmn->createPidFile("/tmp/dmn.pidfile");
	dmn->detach();

	for (;;) {
		cout << "looping..." << endl;
		sleep(1);
	}
}
