// Copyright (c) 2001  David Muse
// See the file COPYING for more information

#include <rudiments/serversocketpool.h>
#include <rudiments/permissions.h>
#include <iostream.h>

int	main() {

	serversocket	serversock;
	serversock.listenOnInetPort(10000,15);

	serversocket	handoffsock;
	handoffsock.listenOnUnixPort("/tmp/handoff.socket",
				permissions::evalPermString("rw-rw-rw-"),15);

	serversocketpool	pool;
	pool.addSocket(&serversock);
	pool.addSocket(&handoffsock);

	genericsocket	*clientsock=NULL;
	genericsocket	*handoffclientsock=NULL;

	for (;;) {

		serversocket	*whichsock;
		genericsocket	*whichclientsock;
		pool.waitForClientConnection(-1,-1,&whichsock,&whichclientsock);

		if (whichsock==&serversock) {
			clientsock=whichclientsock;
		} else if (whichsock==&handoffsock) {
			handoffclientsock=whichclientsock;
		}

		if (clientsock && handoffclientsock) {
			handoffclientsock->passFileDescriptor(
						clientsock->getDescriptor());
			delete clientsock;
			clientsock=NULL;
		}
	}
}
