// Copyright (c) 2001  David Muse
// See the file COPYING for more information

#include <stdlib.h>
#include <rudiments/datetime.h>
#include <rudiments/randomnumber.h>
#include <iostream.h>

int	main() {

        // it's common to seed a random number generator with the number of
        // seconds since 1970 (the epoch), so we'll get the current date.
        datetime        dt;

        cout << "A random number between 0 and " << RAND_MAX << ": ";
        cout << randomnumber::generateNumber(dt.getEpoch());
        cout << endl;

        cout << "A random number between 100 and 1000: ";
        cout << randomnumber::generateScaledNumber(dt.getEpoch(),100,1000);
        cout << endl;

        cout << "Another random number between 100 and 1000: ";
        int     basenumber=randomnumber::generateNumber(dt.getEpoch());
        int     scalednumber=randomnumber::scaleNumber(basenumber,100,1000);
        cout << scalednumber << endl;

        cout << "A random number between -100 and -1000: ";
        cout << randomnumber::generateScaledNumber(dt.getEpoch(),-100,-1000);
        cout << endl;

        cout << "Another random number between -100 and -1000: ";
        basenumber=randomnumber::generateNumber(dt.getEpoch());
        scalednumber=randomnumber::scaleNumber(basenumber,-100,-1000);
        cout << scalednumber << endl;

        cout << "A random number between -100 and 100: ";
        cout << randomnumber::generateScaledNumber(dt.getEpoch(),-100,100);
        cout << endl;

        cout << "Another random number between -100 and 100: ";
        basenumber=randomnumber::generateNumber(dt.getEpoch());
        scalednumber=randomnumber::scaleNumber(basenumber,-100,100);
        cout << scalednumber << endl;
}
