// Copyright (c) 2001  David Muse
// See the file COPYING for more information


#include <rudiments/daemonprocess.h>
#include <rudiments/serversocket.h>

#include <config.h>

#include <stdlib.h>
#include <unistd.h>
#include <iostream.h>

class myserver : public daemonprocess, public serversocket {
	public:
			myserver() : daemonprocess(), serversocket() {}
		void	listen();
};


void	myserver::listen() {

	int	pid=checkForPidFile("/tmp/svr.pidfile");
	if (pid) {
		cout << "Sorry, an instance of this server is already running with process id: " << pid << endl;
		return;
	}

	createPidFile("/tmp/svr.pidfile");
	detach();

	listenOnInetPort(8000,15);

	for (;;) {
		genericsocket	*clientsock=acceptClientConnection();
		char	buffer[11];
		int	sizeread=clientsock->readData(buffer,10);
		buffer[sizeread]=(char)NULL;
		cout << buffer << endl;
		clientsock->writeData("hello",5);
		clientsock->closeSocket();
	}
}

myserver	*mysvr;

RETSIGTYPE	shutDown() {
	cout << "shutting down" << endl;
	delete mysvr;
	unlink("/tmp/svr.pidfile");
	exit(0);
}

int	main() {

	mysvr=new myserver();
	mysvr->handleShutDown((RETSIGTYPE *)shutDown);
	mysvr->listen();
	delete mysvr;
	exit(0);
}
