// Copyright (c) 2001  David Muse
// See the file COPYING for more information

#include <rudiments/text.h>
#include <iostream.h>
#include <string.h>

int	main() {

	// initialize a text buffer and print it out
	char    buffer[100];
	strcpy(buffer,"     hello there buddy     ");
	cout << "!" << buffer << "!" << endl;

	// trim the spaces off of the right hand side
	text::rightTrim(buffer);
	cout << "!" << buffer << "!" << endl;

	// trim the spaces off of the left hand side
	text::leftTrim(buffer);
	cout << "!" << buffer << "!" << endl;

	// strip the spaces out
	strcpy(buffer,"   hello      there   buddy  ");
	text::strip(buffer,' ');
	cout << "!" << buffer << "!" << endl;

	// strip the "   " out
	strcpy(buffer,"   hello       there  buddy  ");
	text::strip(buffer,"   ");
	cout << "!" << buffer << "!" << endl;

	// convert buffer to uppercase
	text::upper(buffer);
	cout << "!" << buffer << "!" << endl;

	// convert buffer to lowercase
	text::lower(buffer);
	cout << "!" << buffer << "!" << endl;

	// http escape the buffer
	char    *escbuffer=text::httpEscape("!@#$%^&*()hello-+");
	cout << "!@#$%^&*()hello-+  http escaped is  " << escbuffer << endl;
	delete escbuffer;
	
	// evaluate a string to see if it's a number
	if (text::isNumber("-100.5")) {
		cout << "-100.5 is a number" << endl;
	}
	if (!text::isNumber("-100.5.10")) {
		cout << "-100.5.10 is not a number" << endl;
	}
	
	// evaluate a string to see if it's an integer
	if (text::isInteger("-100")) {
		cout << "-100 is an integer" << endl;
	}
	if (!text::isInteger("-100.5")) {
		cout << "-100.5.10 is not an integer" << endl;
	}
}
